﻿using System;
using System.Windows.Input;

namespace ComboBoxSelectionDoubleBuffer
{
    class ConfirmationDialogViewModel : NotifyPropertyChangedImpl, IConfirmationDialog
    {
        public ConfirmationDialogViewModel()
        {
            YesCommand = new DelegateCommand(OnYes);
            NoCommand = new DelegateCommand(OnNo);
            _IsVisible = false;
        }

        private bool _IsVisible;
        public bool IsVisible
        {
            get { return _IsVisible; }
            set { _IsVisible = value; RaisePropertyChanged("IsVisible"); }
        }

        private string _Text;
        public string Text
        {
            get { return _Text; }
            set { _Text = value; RaisePropertyChanged("Text"); }
        }

        private Action _YesAction;
        private Action _NoAction;

        public ICommand YesCommand { get; private set; }
        public ICommand NoCommand { get; private set; } 


        public void Show(string text, Action onYes, Action onNo)
        {
            _YesAction = onYes;
            _NoAction = onNo;
            Text = text;
            IsVisible = true;
        }

        private void OnYes()
        {
            IsVisible = false;
            if (_YesAction != null) _YesAction();
        }

        private void OnNo()
        {
            IsVisible = false;
            if (_NoAction != null) _NoAction();
        }


    }
}
