﻿using System.Collections.Generic;

namespace ComboBoxSelectionDoubleBuffer
{
    class MainViewModel : NotifyPropertyChangedImpl
    {
        public MainViewModel()
        {
            ConfirmationDialog = new ConfirmationDialogViewModel();
            SelectedMonth = new DoubleBuffer<string>();
            SelectedMonth.UIValueChanged += OnSelectedMonthChanging;
            SelectedMonth.ValueChanged += OnSelectedMonthChanged;
            SelectedMonth.Assign("January");
        }

        private static readonly string[] _Months = new[]
            {
                "January", "February", "March", "April", "May", "June", "July", 
                "August", "September", "October", "November", "December" 
            };

        public IEnumerable<string> Months { get { return _Months; } }

        public DoubleBuffer<string> SelectedMonth { get; private set; }

        public string Calendar
        {
            get { return _Calendar; }
            set { _Calendar = value; RaisePropertyChanged("Calendar"); }
        }
        private string _Calendar;

        public IConfirmationDialog ConfirmationDialog { get; private set; }

        private void OnSelectedMonthChanging(string toWhat)
        {
            ConfirmationDialog.Show(
                "Are you sure you want to switch to " + toWhat + "?",
                SelectedMonth.ConfirmUIChange,
                SelectedMonth.CancelUIChange);
        }

        private void OnSelectedMonthChanged(string toWhat)
        {
            Calendar = "Calendar for " + toWhat + " goes here";
        }
    }
}
